<?php

defined('_JEXEC') or die('Restricted access');

class CLoader
{
    static private $instance = null;
    
    private $component   = null;    
    private $default     = null;
    
    private $controllers = null;
    private $curentView  = null;    
    private $controller  = null;    
    
    /**
     * @var component   string  Имя компонента
     * @var dafault     string  Контроллер по умолчанию
     */     
    public function __construct($component, $default)
    {
        self::$instance = $this;
        
        $this->component  = $component;
        $this->default    = $default;
        
        $view = JRequest::getWord('view');
        
        if ($view == null && $default) {
            $view = $default;
            JRequest::setVar('view', $view);
        }
        
        $this->curentView = $view;              
    }    
    
    public static function getInstance($component = '', $default = '') 
    {
        if (self::$instance == null) {
            
            if (empty($component) or empty($default)) {
                JError::raiseError('500', 'Обязательные параметры не указаны');
            } 
            
            self::$instance = new self($component, $default);             
        } 
        
        return self::$instance;        
    }
    
    public function getView()
    {
        return $this->curentView;
    }
    
    public function getFormView()
    {
        $view = JRequest::getWord('view');        
        
        if (key_exists($view, $this->controllers)) {
            $controller = $this->controllers[$view];
            list($list, $form) = $controller;            
            
            return $form;    
        } else {            
            return $view;
        }    
   
    }
    
    public function getCurrent()
    {
        if ($this->controller == null) {
            foreach($this->controllers as $name=>$views) {           
                if (in_array($this->curentView, $views)) {
                    $this->controller = $name;
                    
                    return $this->controller;
                    break;
                }
            }
            
        } else {
            return $this->controller;
        }

        if ($this->default) {
            return $this->default;
        } else {
            return false;            
        }                           
    }
    
    public function addController($name, $views = array())
    {
        $this->controllers[$name] = $views;
        
        return;        
    }
    
    public function getController()
    {        
        $controller = $this->getCurrent();  
        
        if (!$controller) {
            JError::raiseError('500', 'Нет доступных контроллеров');
            return false;
        }   
        
        return $this->_createController($controller);                
    }
    
    public function addLinks()
    {
        $all = array_keys($this->controllers);       
        
        foreach($all as $one) 
        {
            $active = (in_array($this->curentView, $this->controllers[$one])) ? true : false;
            JSubMenuHelper::addEntry( JText::_($one), 'index.php?option=com_'. $this->component .'&view='. $one, $active);    
        }
        
        return;        
    }
    
    
    private function _createController($controller)
    {
        $path = JPATH_COMPONENT.DS.'controllers'.DS.$controller.'.php';

        if (is_file($path)) {
            require_once $path;
        } else {            
            JError::raiseError('500', 'Файл контроллера '. $controller .' не найден');
        }
        
        // Создаем экземпляр контроллера
        $classname  = $this->component.'Controller'.$controller;
        $controller = new $classname;
        
        return $controller;
    }
    
    public function component()
    {
        return $this->component;
    }
}