<?php

defined ('_JEXEC') or die('No Access');

jimport('joomla.application.component.model');

class SheduleModelShedule extends JModel
{
    public $_days  = null;
    public $_lines = null;    
    public $_data  = null;
    
    public $days_ids  = null;
    public $lines_ids = null;    
    
    public function __construct()
    {
        parent::__construct();        
    }
    
    public function getItems()
    {
        $lines = $this->getLines();
        $days  = $this->getDays();        
        $data  = $this->getData();
        
        $arr = array();
        
        foreach ($data as $row) {            
            $arr[$row->line_id][$row->day_id] = $row;     
        }            
        
        return $arr;        
    }
    
    public function getDays()
    {
        if ($this->_days == null) {
            $query = "SELECT * "
                    ."  FROM #__shedule_days" 
                    ."  ORDER BY ordering";
            $this->_db->setQuery($query);
            $this->_days = $this->_db->loadObjectList('id');
            
            $this->days_ids = array_keys($this->_days);
        }
        
        return $this->_days;
    }
    
    public function getLines()
    {
        if ($this->_lines == null) {
            $query = 'SELECT *, DATE_FORMAT( stime, \'%H:%i\') as time '
                    .'  FROM #__shedule_lines'
                    .'  WHERE'
                    .'      published = 1'
                    .'  ORDER BY ordering';
            $this->_db->setQuery($query);            
            $this->_lines = $this->_db->loadObjectList('id');
            
            $this->lines_ids = array_keys($this->_lines);
        }
        
        return $this->_lines;        
    }
    
    public function getData()
    {
        if ($this->_data == null) {
            $query = 'SELECT '
                    .'    i.*, '
                    .'    e.name AS event,'
                    .'    u.name AS user'
                    .'  FROM #__shedule_shedule i'
                    .'  INNER JOIN #__shedule_events e'
                    .'    ON i.event_id = e.id'
                    .'  INNER JOIN #__shedule_users u'
                    .'    ON i.user_id = u.id'
                    .'  WHERE '
                    .'    day_id IN('. implode(',', $this->days_ids) .') AND '
                    .'    line_id IN ('. implode(',', $this->lines_ids) .')'
                    .'    AND published = 1';            
            $this->_db->setQuery($query);  
            $data = $this->_db->loadObjectList();
            if ($data)
                $this->_data = $data;
            else
                $this->_data = array();        
        }
        
        return $this->_data;
    }
       
}